#include <wiringPi.h>
#include <stdio.h>
#include <stdlib.h>

// 定义 PWM 引脚的 WiringPi 编号
#define PWM_PIN_SPEED 21
#define PWM_PIN_CHANGE 2
#define SPEED_IN_1 24
#define SPEED_IN_2 26
// 定义 PWM 频率为 50Hz
#define PWM_FREQ 50
// 定义占空比范围，这里设置为 0 到 1000
#define MAX_DUTY 1000



void pwm_speed() {

    int pwm_clock = 24000000 / (PWM_FREQ * 1000);
    pinMode(PWM_PIN_SPEED,PWM_OUTPUT);
    pinMode(PWM_PIN_CHANGE,PWM_OUTPUT);

    pinMode(SPEED_IN_1,OUTPUT);
    pinMode(SPEED_IN_2,OUTPUT);

    pwmSetClock(PWM_PIN_SPEED,pwm_clock);//=19200*1000/(hz*2000)
    pwmSetRange(PWM_PIN_SPEED,MAX_DUTY);
    pwmSetClock(PWM_PIN_CHANGE,pwm_clock);//=19200*1000/(hz*2000)
    pwmSetRange(PWM_PIN_CHANGE,MAX_DUTY);

	pwmWrite(PWM_PIN_SPEED,0);
    pwmWrite(PWM_PIN_CHANGE,80);
    
}

void midde_pwm()
{
    pwmWrite(PWM_PIN_SPEED,0);
    pwmWrite(PWM_PIN_CHANGE,80);
}

void mode_1_flont(unsigned char gval)
{
	digitalWrite(SPEED_IN_1, HIGH);
	digitalWrite(SPEED_IN_2, LOW);
    if(gval<=50)
	{
		pwmWrite(PWM_PIN_SPEED,0);
	}
	if(50<gval&&gval<=55)
	{
		pwmWrite(PWM_PIN_SPEED,100);
	}
	if(55<gval&&gval<=60)
	{
		pwmWrite(PWM_PIN_SPEED,200);
	}
	if(60<gval&&gval<=65)
	{
		pwmWrite(PWM_PIN_SPEED,300);
	}
	if(65<gval&&gval<=70)
	{
		pwmWrite(PWM_PIN_SPEED,400);
	}
	if(70<gval&&gval<=75)
	{
		pwmWrite(PWM_PIN_SPEED,500);
	}
	if(75<gval&&gval<=90)
	{
		pwmWrite(PWM_PIN_SPEED,600);
	}
	if(90<gval&&gval<=100)
	{
		pwmWrite(PWM_PIN_SPEED,700);
        
	}
}

void mode_2_back(unsigned char gval)
{
	digitalWrite(SPEED_IN_2, HIGH);
	digitalWrite(SPEED_IN_1, LOW);
   if(gval<=50)
	{
		pwmWrite(PWM_PIN_SPEED,0);
	}
	if(50<gval&&gval<=55)
	{
		pwmWrite(PWM_PIN_SPEED,100);
	}
	if(55<gval&&gval<=60)
	{
		pwmWrite(PWM_PIN_SPEED,200);
	}
	if(60<gval&&gval<=65)
	{
		pwmWrite(PWM_PIN_SPEED,300);
	}
	if(65<gval&&gval<=70)
	{
		pwmWrite(PWM_PIN_SPEED,400);
	}
	if(70<gval&&gval<=75)
	{
		pwmWrite(PWM_PIN_SPEED,500);
	}
	if(75<gval&&gval<=90)
	{
		pwmWrite(PWM_PIN_SPEED,600);
	}
	if(90<gval&&gval<=100)
	{
		pwmWrite(PWM_PIN_SPEED,700);
        
	}
}

void mode_3_left(unsigned char gval)
{
    if(gval<=45)
	{
	pwmWrite(PWM_PIN_CHANGE,80);
	}
	if(gval>45&&gval<=51)
	{
		pwmWrite(PWM_PIN_CHANGE,92);
	}
	if(gval>51&&gval<=57)
	{
		pwmWrite(PWM_PIN_CHANGE,95);
	}
	if(gval>57&&gval<=63)
	{
		pwmWrite(PWM_PIN_CHANGE,98);
	}
	if(gval>63&&gval<=69)
	{
		pwmWrite(PWM_PIN_CHANGE,100);
	}
	if(gval>69&&gval<=75)
	{
		pwmWrite(PWM_PIN_CHANGE,105);
	}
}

void mode_4_right(unsigned char gval)
{
    if(gval<=45)
	{
		pwmWrite(PWM_PIN_CHANGE,80);
	}
	if(gval>45&&gval<=51)
	{
		pwmWrite(PWM_PIN_CHANGE,68);
	}
	if(gval>51&&gval<=57)
	{
		pwmWrite(PWM_PIN_CHANGE,65);
	}
	if(gval>57&&gval<=63)
	{
		pwmWrite(PWM_PIN_CHANGE,62);
	}
	if(gval>63&&gval<=69)
	{
		pwmWrite(PWM_PIN_CHANGE,60);
	}
	if(gval>69&&gval<=75)
	{
		pwmWrite(PWM_PIN_CHANGE,55);
	}
}

void speed_change(unsigned char *buf)//速度和转向引脚数值处理函数
{
    unsigned char mode=buf[1];
    unsigned char val=buf[2];

    switch(mode)
    {
        case 1:			
		mode_1_flont(val);					 
			break;
		case 2:	
			mode_2_back(val);
			break;
		case 3:
			mode_3_left(val);
			break;
		case 4:
			mode_4_right(val);
			break; 
        default:
			break;
    }
    
}